''
'' pin delay mapper
''
''        Author: Marko Lukat
'' Last modified: 2010/12/04
''       Version: 0.2
''
CON
  _clkmode = XTAL1|PLL16X
  _xinfreq = 5_000_000

CON
  pins = $0FFFF0FF              ' demoboard
  
OBJ
  serial: "FullDuplexSerial"

  A: "delay.map.outa.demoboard"
  B: "delay.map.phsx.demoboard"
  C: "delay.map.outa.ppdb"
  D: "delay.map.phsx.ppdb"
  
VAR
  long  cog, storage[32 * 8 * 8]
  long  stack[128]
  
PUB null

  waitcnt(clkfreq*3 + cnt)
  coginit(cog, check, @stack[64*(cog&1)])
  
PRI check | rx, tx, io, address

  dira := pins

  repeat tx from 0 to 7
    if tx <> cog
      repeat rx from 0 to 7
        if rx <> cog and rx <> tx
          repeat io from 0 to 31
            if dira[io]
              address := (tx << 3 + rx) << 5 + io
              storage[address] := io
              byte[0] := TRUE
              coginit(rx, @catch, @storage[address])
              coginit(tx, @start, @storage[address])
              repeat while byte[0]
            
  if ++cog & 7
    coginit(cog, check, @stack[64*(cog&1)])
    return
  
  serial.start(31, 30, %0000, 115200)                   ' report results
  serial.tx(0)

  header(FALSE, 10)
  header(TRUE, 1)
      
  repeat tx from 0 to 7
    repeat rx from 0 to 7
      if rx <> tx
        serial.dec(tx)
        serial.tx(".")
        serial.dec(rx)
        serial.tx(":")
        repeat io from 0 to 31
          address := (tx << 3 + rx) << 5 + io
          serial.tx(32)
          serial.tx(lookupz(storage[address]: ".", 0, 0, "-", "#"))
        serial.tx(13)

  header(TRUE, 10)
  header(FALSE, 1)

PRI header(close, div) | io

  if close
    serial.str(string("T.R:"))
  else
    serial.str(string("    "))

  repeat io from 0 to 31
    serial.tx(32)
    serial.dec(io / div // 10)
  serial.tx(13)

DAT             org     0                       ' positive edge generator

start           rdbyte  ctrb, par
                shl     m_tx, ctrb
                mov     dira, m_tx
{
                movi    ctrb, #%0_00100_000     '
                neg     phsb, #1                '                       ** phsx
}
                or      outa, m_tx              ' low high edge         ** outa

                mov     cnt, cnt
                wrlong  cnt, par

                cogid   cnt
                cogstop cnt

' initialised data and/or presets

m_tx            long    1

' uninitialised data and/or temporaries

                fit
                
DAT             org     0                       ' positive edge detector

catch           rdbyte  ctrb, par
                shl     m_rx, ctrb
                
                waitpeq m_rx, m_rx              ' wait for low high edge
                mov     eins, cnt

                mov     cnt, #16
                djnz    cnt, #$
                
                rdlong  zwei, par
                sub     eins, zwei

                wrlong  eins, par
                wrbyte  par, #0

                cogid   cnt
                cogstop cnt

' initialised data and/or presets

m_rx            long    1

' uninitialised data and/or temporaries

eins            res     1
zwei            res     1

                fit
                
DAT